Attribute VB_Name = "Callback"
Option Explicit

' Typ-Deklarationen
Type POINTAPI
        x As Long
        y As Long
End Type

Type MINMAXINFO
    ptReserved As POINTAPI
    ptMaxSize As POINTAPI
    ptMaxPosition As POINTAPI
    ptMinTrackSize As POINTAPI
    ptMaxTrackSize As POINTAPI
End Type

' API-Deklarationen
Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hwnd As Long, ByVal MSG As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Declare Sub CopyMemory Lib "KERNEL32" Alias "RtlMoveMemory" (lpDest As Any, lpSource As Any, ByVal nCount As Long)

' Konstante
Public Const WM_GETMINMAXINFO = &H24
Public Const GWL_WNDPROC = (-4)

' Variable
Public OldProc As Long  ' Adresse der originalen WindowProc


Public Function WindowProc(ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long

   If wMsg = WM_GETMINMAXINFO Then
   
        Dim MinMax As MINMAXINFO
        
        ' lParam lokale Variable kopieren
        CopyMemory MinMax, ByVal lParam, Len(MinMax)
        
        ' Maximale Gre setzen
        With MinMax
            
            ' Jedes der Wertepaare ist optional, es knnen also auch
            ' einzelne dieser Funktionalitten eingesetzt werden.
            
            ' Minimale Gre (in Pixel)
            .ptMinTrackSize.x = 310     ' Min. Breite
            .ptMinTrackSize.y = 230     ' Min. Hhe
            
            ' Maximale Gre
            .ptMaxTrackSize.x = 620     ' Max. Breite
            .ptMaxTrackSize.y = 320     ' Max. Hhe
            
            ' Gre als maximiertes Fenster
            ' VORSICHT: Diese Werte werden, soweit grer als selbige,
            ' --------- von den ptMaxTrackSize-Werten bersteuert!
            
            .ptMaxSize.x = 550          ' Maximierte Breite
            .ptMaxSize.y = 230          ' Maximierte Hhe
            
            ' Position als maximiertes Fenster
            .ptMaxPosition.x = 50       ' Linker Rand in maximiertem Zustand
            .ptMaxPosition.y = 50       ' Oberer Rand in maximiertem Zustand
            
        End With
        
        ' Werte wieder zurckschreiben
        CopyMemory ByVal lParam, MinMax, Len(MinMax)

    Else
    
        ' Nachricht an originale Routine weiterleiten
        WindowProc = CallWindowProc(OldProc, hwnd, wMsg, wParam, lParam)
        
    End If
    
End Function
